#pragma once

#include "Array.h"
#include "Critical.h"

namespace Framework
{
    struct DLLDatei
    {
        Text *name;
        HINSTANCE handle;
        int ref;
    };

    class DLLRegister
    {
    private:
        Array< DLLDatei * > *dlls;
        Critical cs;
        int ref;

    public:
        // Konstruktor
        __declspec(dllexport) DLLRegister();
        // Destruktor
        __declspec( dllexport ) ~DLLRegister();
        // nicht constant       
        __declspec( dllexport ) HINSTANCE ladeDLL( char *name, char *pfad );
        __declspec( dllexport ) void releaseDLL( char *name );
        // Reference Counting   
        __declspec( dllexport ) DLLRegister *getThis();
        __declspec( dllexport ) DLLRegister *release();
    };
}